var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgfossilcustomv4png = new Image();
var imgCOMPLICATION017556917256121796batterybgpng = new Image();
var imgCOMPLICATION017556917256121796battery01png = new Image();
var imgCOMPLICATION017556917256121796battery02png = new Image();
var imgCOMPLICATION017556917256121796battery03png = new Image();
var imgCOMPLICATION017556917256121796battery04png = new Image();
var imgCOMPLICATION017556917256121796battery05png = new Image();
var imgCOMPLICATION017556917256121796battery06png = new Image();
var imgCOMPLICATION017556917256121796battery07png = new Image();
var imgCOMPLICATION017556917256121796battery08png = new Image();
var imgCOMPLICATION017556917256121796battery09png = new Image();
var imgCOMPLICATION017556917256121796battery10png = new Image();
var imgCOMPLICATION017556917256121796battery11png = new Image();
var imgCOMPLICATION017556917256121796battery12png = new Image();
var imgCOMPLICATION017556917256121796battery13png = new Image();
var imgCOMPLICATION017556917256121796battery14png = new Image();
var imgCOMPLICATION017556917256121796battery15png = new Image();
var imgCOMPLICATION017556917256121796battery16png = new Image();
var imgCOMPLICATION017556917256121796battery17png = new Image();
var imgCOMPLICATION017556917256121796battery18png = new Image();
var imgCOMPLICATION017556917256121796battery19png = new Image();
var imgCOMPLICATION017556917256121796battery20png = new Image();

var Image22ButtonArea = [64, 137, 151, 224];
var imgCOMPLICATION017556917256121796batterywarnpng = new Image();
var imgCOMPLICATION017556917256121796batterynorpng = new Image();
var imghrpng = new Image();
var imgminpng = new Image();
var imgsecpng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgfossilcustomv4png.src = "fossilcustomv4.png";
    context.drawImage(imgfossilcustomv4png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "16px Digital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "Text";
    context.fillText(text, 253, 184);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "bold 12px Digital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#606060";
    text = "Steps";
    context.fillText(text, 253, 200);
    context.restore();
    context.save();

    var Image1Condition= [[0, 100]];
    if (findByValue(false, Image1Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796batterybgpng.src = "COMPLICATION0.17556917256121796batterybg.png";
        context.drawImage(imgCOMPLICATION017556917256121796batterybgpng, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image2Condition= [[5, 10]];
    if (findByValue(false, Image2Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery01png.src = "COMPLICATION0.17556917256121796battery01.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery01png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image3Condition= [[10, 15]];
    if (findByValue(false, Image3Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery02png.src = "COMPLICATION0.17556917256121796battery02.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery02png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image4Condition= [[15, 20]];
    if (findByValue(false, Image4Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery03png.src = "COMPLICATION0.17556917256121796battery03.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery03png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image5Condition= [[20, 25]];
    if (findByValue(false, Image5Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery04png.src = "COMPLICATION0.17556917256121796battery04.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery04png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image6Condition= [[25, 30]];
    if (findByValue(false, Image6Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery05png.src = "COMPLICATION0.17556917256121796battery05.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery05png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image7Condition= [[30, 35]];
    if (findByValue(false, Image7Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery06png.src = "COMPLICATION0.17556917256121796battery06.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery06png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image8Condition= [[35, 40]];
    if (findByValue(false, Image8Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery07png.src = "COMPLICATION0.17556917256121796battery07.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery07png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image9Condition= [[40, 45]];
    if (findByValue(false, Image9Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery08png.src = "COMPLICATION0.17556917256121796battery08.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery08png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image10Condition= [[45, 50]];
    if (findByValue(false, Image10Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery09png.src = "COMPLICATION0.17556917256121796battery09.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery09png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image11Condition= [[50, 55]];
    if (findByValue(false, Image11Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery10png.src = "COMPLICATION0.17556917256121796battery10.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery10png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image12Condition= [[55, 60]];
    if (findByValue(false, Image12Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery11png.src = "COMPLICATION0.17556917256121796battery11.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery11png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image13Condition= [[60, 65]];
    if (findByValue(false, Image13Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery12png.src = "COMPLICATION0.17556917256121796battery12.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery12png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image14Condition= [[65, 70]];
    if (findByValue(false, Image14Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery13png.src = "COMPLICATION0.17556917256121796battery13.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery13png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image15Condition= [[70, 75]];
    if (findByValue(false, Image15Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery14png.src = "COMPLICATION0.17556917256121796battery14.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery14png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image16Condition= [[75, 80]];
    if (findByValue(false, Image16Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery15png.src = "COMPLICATION0.17556917256121796battery15.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery15png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image17Condition= [[80, 85]];
    if (findByValue(false, Image17Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery16png.src = "COMPLICATION0.17556917256121796battery16.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery16png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image18Condition= [[85, 90]];
    if (findByValue(false, Image18Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery17png.src = "COMPLICATION0.17556917256121796battery17.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery17png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image19Condition= [[90, 95]];
    if (findByValue(false, Image19Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery18png.src = "COMPLICATION0.17556917256121796battery18.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery18png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image20Condition= [[95, 99]];
    if (findByValue(false, Image20Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery19png.src = "COMPLICATION0.17556917256121796battery19.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery19png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    var Image21Condition= [[99, 100]];
    if (findByValue(false, Image21Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796battery20png.src = "COMPLICATION0.17556917256121796battery20.png";
        context.drawImage(imgCOMPLICATION017556917256121796battery20png, 64, 137, 87, 87);
        context.restore();
        context.save();
    }

    context.beginPath();
    context.font = "16px Digital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "Text";
    context.fillText(text, 111, 186);
    context.restore();
    context.save();

    gImage.src = "COMPLICATION0.17556917256121796batterygaugeaction.png";
    context.drawImage(imgCOMPLICATION017556917256121796batterygaugeactionpng, 64, 137, 87, 87);
    context.restore();
    context.save();

    var Image23Condition= [[0, 15]];
    if (findByValue(false, Image23Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796batterywarnpng.src = "COMPLICATION0.17556917256121796batterywarn.png";
        context.drawImage(imgCOMPLICATION017556917256121796batterywarnpng, 63, 135, 87, 87);
        context.restore();
        context.save();
    }

    var Image24Condition= [[15, 100]];
    if (findByValue(false, Image24Condition, Math.floor(battery.level*100))) {
        imgCOMPLICATION017556917256121796batterynorpng.src = "COMPLICATION0.17556917256121796batterynor.png";
        context.drawImage(imgCOMPLICATION017556917256121796batterynorpng, 63, 135, 87, 87);
        context.restore();
        context.save();
    }

    context.beginPath();
    context.font = "bold 18px digital7mono";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 179, 247);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "bold 32px Digital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = ((date.getHours()<10) ? "0"+date.getHours() : date.getHours().toString()) + ":" + ((minutes<10) ? "0"+minutes : minutes.toString());
    context.fillText(text, 178, 125);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "18px Digital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = dayOfWeek[date.getDay()] + "," + monthStr[date.getMonth()];
    context.fillText(text, 181, 217);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imghrpng.src = "hr.png";
    context.drawImage(imghrpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgminpng.src = "min.png";
    context.drawImage(imgminpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgsecpng.src = "sec.png";
    context.drawImage(imgsecpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Image22ButtonArea[0] && e.changedTouches[0].clientX < Image22ButtonArea[2] && e.changedTouches[0].clientY >= Image22ButtonArea[1] && e.changedTouches[0].clientY < Image22ButtonArea[3]) {
            tizen.application.launch("battery");
        }
    });
};
